;--------------------------------------------
; }N`
Mapping16KB     macro   SEGADDR:REQ,  WINDOW_NO:REQ , PAGE_NO:REQ
                mov     SegBase,SEGADDR
                mov     Window,WINDOW_NO
                mov     MemPage,PAGE_NO
                call    CheckROM16KB
                jnz     @f
                call    AllocatePage
                call    PageClear
        @@:
endm
;---------------------------------------------------
CheckROM16KB    PROC   near     ;  SegBase
                xor     ax,ax
                mov     ExistFlag,al
                mov     es,SegBase
                mov     di,ax
                mov     cx,4000h/2      ; 16KB =8Kword
                mov     dx,ax
                not     dx
CheckEnt:
                mov     ax,es:[di]
                cmp     ax,dx
                je      @f
                mov     ExistFlag,1
        @@:     inc     di
                inc     di
               loop     CheckEnt
                test    ExistFlag,1   ; Z=ׂFFh(gp), NZ=gpłȂ
                ret
CheckROM16KB    ENDP
;---------------------------------------------------
AllocatePage    PROC   near     ;  Window,Page,SegBase
; oEBhEԍw肵APJEBhE
                mov     al,Window
                mov     dx,PortEMJ_win
                out     dx,al
                out     5Fh,al  ; I/O ̌㎞ԑ҂ق悢炵H
; ɃEBhẼZOgw肷 
                mov     ax,SegBase
                xchg    al,ah
                and     al,11111100b    ; lower bit mask
                mov     dx,PortEMJ_addr
                out     dx,al          ; byte
                out     5Fh,al
; Ƀy[Wԍw肷ƁÃZOgԒnɃ悤ɂȂ
                mov     ax,MemPage
                or      ax,8000h
                mov     dx,PortEMJ_page
                out     dx,ax           ; AX=y[Wԍ|8000h 
                out     05Fh,al
                ret
AllocatePage    ENDP
msg_SearchEMJ   DB      "R EMJ{[hT܂...",13,0
msg_FoundEMJ    DB      "R EMJ{[h݂܂.  EMSɂ͎gpȂł.",13,0
msg_EMJSET      DB      "R EMJ{[hD0,D4Ɋt܂.              MELEMM.SYS͎gp֎~ł.",13,0
;--------------------------------------------------------------------------
ScanEMJ_E8D0    PROC   near
                mov     dx,offset msg_SearchEMJ
                call    puts

                mov     cx,0010h    ; l{[hԍ(SW1)0Fh
                mov     dx,PortEMJ_base
ScanEMJ_loop: 
                mov     ax,cx   ; {[hԍ
                dec     ax      ; PI/OAhX
                cmp     ax,1    ; 
                jb      ErrorExit ; PɂȂ璆~
                shl     ax,1    ; Vtgax,8 Ɠ
                shl     ax,1
                shl     ax,1
                shl     ax,1
                shl     ax,1
                shl     ax,1
                shl     ax,1
                shl     ax,1
                and     dx,0F0FFh ; bit8~11 }XN
                add     dx,ax     ; Zbit8~11m
                in      al,dx     ; 
                cmp     al,0FFh   ; ͒lFFȂ{[hs
                jne     FoundEMJ  ; łȂΑ݁Ã`FbNɔ
               Loop     ScanEMJ_loop

FoundEMJ:       ; 4bit SW2̓ǂݏol
                and     al,07h   ;s}XN        
                cmp     al,04h   ; l4܂ĈƂEMSp̐ݒ
                jne     ErrorExit ; ȊÕ[ĥƂ͒~
                mov     ax,dx   ; I/OAhXg
                mov     PortEMJ_addr,ax ; AhXтI/OAhX
                dec     dx
                mov     PortEMJ_win,dx  ; EBhEԍI/OAhX
                add     dx,1000h
                mov     PortEMJ_page,dx ; y[WԍI/OAhX
                ; ܂łŃ^[Qbg̃{[hI/OAhXm
                mov     dx,offset msg_FoundEMJ
                call    puts
                mov     UseEMJ,1
                clc
                ret
ErrorExit:      
                stc
                ret
ScanEMJ_E8D0    ENDP


SetEMJ_E800     PROC   near
                Mapping16KB  0E800h,7,0007h
                ret
SetEMJ_E800     ENDP

SetEMJ_D000     PROC   near
                Mapping16KB  0D000h,4,0004h
                ret
SetEMJ_D000     ENDP

SetEMJ_D400     PROC   near
                Mapping16KB  0D400h,5,0005h
                ret
SetEMJ_D400     ENDP

SetEMJ_D800     PROC   near
                Mapping16KB  0D800h,6,0006h
                ret
SetEMJ_D800     ENDP

SetEMJ_DC00     PROC   near
                Mapping16KB  0DC00h,7,0007h
                ret
SetEMJ_DC00     ENDP

; ϐ`
PortEMJ_base    equ     61EFh
align 2
ExistFlag       DB      0
Window          DB      0
MemPage         DW      0
SegBase         DW      0
PortEMJ_win     DW      0
PortEMJ_addr    DW      0
PortEMJ_page    DW      0
UseEMJ          DB      0

;--------------------------------------------------------------------------
PageClear       PROC   near
;               push    ax
;               push    bx
;               push    cx
;               push    di
;               push    es
                mov     cx,4
                mov     bx,SegBase  ; ZOgݒ
loop4KB_ent:    mov     di,0
                mov     es,bx       ; ZOgݒes:[di]
ifdef   DEBUGGING
                mov     ah,bh       ; ZOgʂ݃f[^ɂ
                mov     al,Window   ; EBhEԍ݃f[^ɂ
else
                mov     ax,0
endif
                 push    cx
                 mov     cx,1000h/2
        rep      stosw          ; 4KB̃p^[
                 pop     cx
                add     bx,0100h        ; ZOg4KBi߂
               loop     loop4KB_ent
;               pop     es
;               pop     di
;               pop     cx
;               pop     bx
;               pop     ax
                ret
PageClear       ENDP
;--------------------------------------------------------------------------
