;----------------------------------------------------------------------------
;       PCIUMB.SYS  Copyright(C) 2023 ܂(DOSsoft)  foCXhCo
;----------------------------------------------------------------------------
code    segment
        assume  cs:code

                org     0h              ;  fohpɂ͕K{
.8086
start:          
header:                          ;      code
                DD      0FFFFFFFFh      ;Original Header(link to FFFF:FFFF)
dev_attr        DW      8000h           ;Device Attributes
                DW      strategy        ;Device Strategy Entry Pointer
                DW      dev_intr        ;Device Interupt Entry Pointer
dev_name        DB      '$PCIUMB$'
                DB      8 dup(0)
packet          DD      ?               ;command packet address

dev_routine     proc    far
strategy:       mov     word ptr cs:[packet    ],bx
                mov     word ptr cs:[packet + 2],es
                ret
dev_intr:
                cld
                push    ax
                push    bx
                push    cx
                push    dx
                push    si
                push    di
                push    ds
                push    es
                lds     di,cs:[packet]
                cmp     byte ptr [di + 2],00h
                jnz     dev_init_error
dev_init:       mov     ax,cs
                mov     ds,ax
                lds     si,cs:[packet]
                lds     si,ds:[si + 18]
;-------- .EXE PROGRAM s ---------------
                call    DEV_start
;-------- .EXE PROGRAM sI----------
;       L͎ۂɂ͎sȂĂ悢炵
                push    cs
                pop     es
                push    cs
                pop     ds
                mov     word ptr cs:[header    ],0ffffh
                mov     word ptr cs:[header + 2],0ffffh
                mov     word ptr cs:[dev_attr],0
                lds     di,cs:[packet]
                mov     byte ptr [di + 13],0	;	unit 
                mov     word ptr [di + 14],offset header
                mov     word ptr [di + 16],cs
                mov     word ptr [di + 3],08Eh    ;       status
                jmp     dev_intr_ret
dev_init_error: 
                mov     word ptr [di + 3],8103h ;  command error status
dev_intr_ret:
                pop     es
                pop     ds
                pop     di
                pop     SI
                pop     dx
                pop     cx
                pop     bx
                pop     ax
                RET
dev_routine     ENDP

;               fohvÔƂ
DEV_start:      ; fohLqC] to param_area
                ; DS:SI R}hCs 
; R}hCsXLāAp[^擪ɎĂB
                mov     ax,cs
                mov     es,ax   ; ES=CS
                mov     ax,cs
                mov     ds,ax   ; DS=ES=CS
;                mov     dx,offset param_area
;                call    _puts
                call    MainStart       ; ʃ[`
                ret
                DB      83h
;--------------------------------------------------------------------------
include puts09.s
include pumbmain.s
;--------------------------------------------------------------------------
code    ends
        end     start

